﻿/* SPJS Autocomplete for SharePoint v1.4
 * ---------------------------------------------
 * Created by Alexander Bautz
 * alexander.bautz@gmail.com
 * http://spjsblog.com
 * Copyright (c) 2014-2016 Alexander Bautz (Licensed under the MIT X11 License)
 * ---------------------------------------------
*/

var spjs = spjs || {};

spjs.ac = {
	"version":"1.4",
	"versionDate":"February 19, 2016",
	"data":{
		"styleTagWritten":false,
		"baseUrl":"",
		"usersInGroup":{},
		"isSP07":typeof _spPageContextInfo === "undefined" || _spPageContextInfo.webUIVersion === undefined,
		"isSP13":typeof _spPageContextInfo !== "undefined" && _spPageContextInfo.webUIVersion === 15 ? true : false,
		"isDispForm":location.href.replace("_layouts/15/start.aspx#/","").split("&")[0].match(/dispform.aspx/i) !== null,
		"debug":GetUrlKeyValue("SPJSAcDebug") === "1",
		"argObj":{}
	},
	"getLocalized":function(){
		var lcid = "";
		if(!spjs.ac.data.isSP07){
			lcid = _spPageContextInfo.currentLanguage.toString();
		}else{
			lcid = L_Menu_LCID;
		}
		switch(lcid){
			case "1044":
				spjs.ac.text = {
					"imgTitle":"Listen over gyldige valg oppdateres automatisk når du skriver",
					"noItems":"Ingen elementer samsvarer med søket",
					"addNewItem":"Legg til {0} i listen?",
					"noValidItems":"Ingen gyldige elementer funnet",
					"invalid":"Ugyldig verdi",
					"moreItemsLabel":"Viser de {0} første elementene",
					"moreItemsMouseover":"Fortsett å skrive for å begrense søket",
					"searching":"Søker etter: "
				};
			break;
			default:
				spjs.ac.text = {
					"imgTitle":"The list of valid choices is updated automatically when you type",
					"noItems":"No items match your search",
					"addNewItem":"Add {0} to the list?",
					"noValidItems":"No valid items match your search",
					"invalid":"Invalid value",
					"moreItemsLabel":"Showing the first {0} items",
					"moreItemsMouseover":"Continue typing to narrow your search",
					"searching":"Searching for: "
				};
		}
	},	
	"applyCSS":function(){
		var cssBuffer = [];
		cssBuffer.push("<style type=\"text/css\">");
		cssBuffer.push(".spjs_acWrap{background-color:#FFFFFF;border:1px silver solid;display:none;position:absolute;min-width:200px;cursor:default;white-space:nowrap;z-index:999;}");
		cssBuffer.push(".spjs_acItem{border-left:2px transparent solid;padding:4px;cursor:pointer;white-space:nowrap;}");
		cssBuffer.push(".spjs_acSelected{background-color:#BFEFFF;border-left:2px #00B2EE solid;}");
		cssBuffer.push(".spjs_acNotFound{padding:4px;cursor:default;white-space:nowrap;color:#818181;}");
		cssBuffer.push(".spjs_acError{background-color:#FFCCCC;font-style:italic;}");
		cssBuffer.push(".spjs_acItemMoreItems{border-top:1px silver solid;padding:4px;color:#818181;}");
		cssBuffer.push("<\/style>");
		jQuery(document).ready(function(){
			jQuery("body").append(cssBuffer.join(""));
		});
		spjs.ac.data.styleTagWritten = true;
	},
	"imgErr":function(img){
		jQuery(img).attr("src","/_layouts/images/IMNIDLE.PNG");
	},
	"textField":function(argObj){
		if(spjs.ac.data.isDispForm){
			// You cannot use the Autocomplete solution in DispForm
			return;
		}
		if(jQuery("#spjs_acWrap_"+argObj.applyTo).length === 0){
			argObj.fieldType = "textField";
			spjs.ac.add(argObj);
		}
	},
	"peoplePicker":function(argObj){
		if(spjs.ac.data.isDispForm){
			// You cannot use the Autocomplete solution in DispForm
			return;
		}
		if(spjs.utility.version < 1.181){
			alert("[Autocomplete for SharePoint]\n\nYou must update spjs-utility.js to v1.181 or above.");
		}
		if(jQuery("#spjs_acWrap_"+argObj.applyTo).length === 0){
			argObj.fieldType = "peoplePicker";
			argObj.listGuid = "UserInfo";
			if(spjs.ac.data.isSP13 && !argObj.forceOn2013){
				alert("[SPJS Autocomplete]\n\nThis solution cannot be used for a people picker field in SP2013 as this field already have built in autocomplete.");
			}else{
				jQuery(document).ready(function(){
					spjs.ac.add(argObj);
				});
			}
		}
	},
	"hideHelp":function(fin){
		jQuery("#spjs_acHelp_"+fin).hide().next().focus().trigger("click");
	},
	"add":function(argObj){
		if(spjs.ac.data.isSP13){
			if(jQuery("td.ms-formbody span[id*='"+_spPageContextInfo.pageListId.replace(/\{|\}/g,"")+"']").length>0){
				setTimeout(function(){
					spjs.ac.add(argObj);
				},10);
				return;
			}
		}
		if(fields[argObj.applyTo] === undefined){
			alert("[SPJS Autocomplete for SharePoint]\n\nThe field \""+argObj.applyTo+"\" could not be found.");
			return;
		}		
		if(!spjs.ac.data.isSP07){
			spjs.ac.data.baseUrl = _spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl : "";
		}else{
			spjs.ac.data.baseUrl = L_Menu_BaseUrl;
		}
		var hb;
		if(!spjs.ac.data.styleTagWritten){
			spjs.ac.applyCSS();
		}
		spjs.ac.data.argObj[argObj.applyTo] = argObj;
		spjs.ac.data[argObj.applyTo] = {	
			"clicked":false,
			"trigger":false,
			"loadVal":getFieldValue(argObj.applyTo).toString(),
			"setFields":argObj.setFields !== undefined ? argObj.setFields : [],
			"timeout":0,
			"text":{},
			"selectedIndex":null,
			"selectedValue":"",
			"currentValue":"",
			"foundExactMatch":0
		};
		if(spjs.ac.data[argObj.applyTo].loadVal.split(";#").length > 1){
			spjs.ac.data[argObj.applyTo].loadVal = spjs.ac.data[argObj.applyTo].loadVal.split(";#")[1];
		}
		if(spjs.ac.text === undefined){
			spjs.ac.getLocalized();
		}
		spjs.ac.data[argObj.applyTo].text = spjs.ac.text;
		if(argObj.listGuid===undefined){
			alert("[spjs.ac]\nThe configuration for field \""+argObj.applyTo+"\" has an invalid list GUID configured.");
			return;
		}
		jQuery(fields[argObj.applyTo]).attr("spjs_ac","1");	
		hb = [];
		hb.push("<div id='spjs_acWrap_"+argObj.applyTo+"' style='white-space:nowrap'>");
		hb.push("<span id='spjs_acHelp_"+argObj.applyTo+"' onclick='spjs.ac.hideHelp(\""+argObj.applyTo+"\");' style='position:absolute;padding:3px 0px 0px 4px;color:#818181;display:none;'>"+argObj.helpText+"</span>");
		hb.push("<input id='spjs_ac_"+argObj.applyTo+"' type='text' class='ms-long' style='min-height:13px;margin:0px;' value='"+spjs.ac.data[argObj.applyTo].loadVal+"' autocomplete='off'>");
		hb.push("<img id='statusImg_"+argObj.applyTo+"' title='"+spjs.ac.data[argObj.applyTo].text.imgTitle+"' src='/_layouts/images/IMNOFF.PNG' style='border:0px;padding-left:4px;' />");
		hb.push("<img id='prosessingImg_"+argObj.applyTo+"' src='/_layouts/images/loadingcirclests16.gif' onerror='spjs.ac.imgErr(this)' style='height:12px;border:0px;padding-left:4px;display:none' />");
		hb.push("<div id='spjs_acWrapFormValidation_"+argObj.applyTo+"'></div>");
		hb.push("</div>");
		hb.push("<div class='spjs_acWrap' id='spjs_acPlaceholder_"+argObj.applyTo+"'></div>");
		hb.push("<span class='spjs_acError' id='spjs_acError_"+argObj.applyTo+"'></span>");
		if(spjs.ac.data.debug){
			jQuery(fields[argObj.applyTo]).find("td.ms-formbody span:first").after(hb.join(""));
		}else{
			jQuery(fields[argObj.applyTo]).find("td.ms-formbody span:first").hide().after(hb.join(""));
		}
		if(jQuery(fields[argObj.applyTo]).find("span.ms-formvalidation").length > 0){
			jQuery(fields[argObj.applyTo]).find("td.ms-formbody span.ms-formvalidation, td.ms-formbody span.ms-error").appendTo(jQuery("#spjs_acWrapFormValidation_"+argObj.applyTo));
		}
		if(argObj.listOptionsOnFocus !== undefined && argObj.listOptionsOnFocus){
			jQuery("#spjs_ac_"+argObj.applyTo).after("<img title='' src='/_layouts/images/DROPDOWN.GIF' style='vertical-align:top;' onclick='jQuery(this).prev().click();' />");
		}		
		jQuery(fields[argObj.applyTo]).find("input:last").on("focus",function(){
			jQuery("#spjs_acHelp_"+argObj.applyTo).hide();
			spjs.ac.data[argObj.applyTo].pVal = jQuery(this).val();
		}).on("click",function(e){			
			if(argObj.listOptionsOnFocus || jQuery(this).hasClass("spjs_acError")){				
				clearTimeout(spjs.ac.data[argObj.applyTo].timeout);
				spjs.ac.data[argObj.applyTo].timeout = setTimeout(function(){
					spjs.ac.handle(argObj);					
				},500);
			}
		}).on("keyup",function(e){			
			if(e.keyCode === 13 || e.keyCode === 38 || e.keyCode === 40){
				return;
			}
			clearTimeout(spjs.ac.data[argObj.applyTo].timeout);
			spjs.ac.data[argObj.applyTo].timeout = setTimeout(function(){
				spjs.ac.handle(argObj);
			},500);
		}).on("blur",function(){
			if(jQuery(this).val() === ""){
				jQuery("#spjs_acHelp_"+argObj.applyTo).show();
			}
			clearTimeout(spjs.ac.data[argObj.applyTo].timeout);
			spjs.ac.data[argObj.applyTo].timeout = setTimeout(function(){				
				if(!spjs.ac.data[argObj.applyTo].clicked || jQuery("#spjs_ac_"+argObj.applyTo).val() === ""){
					if(jQuery("#spjs_ac_"+argObj.applyTo).val() === ""){
						spjs.ac.data[argObj.applyTo].selectedIndex = 0;						
					}
					spjs.ac.verify(argObj.applyTo);
				}
				jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide();		
			},250);
		}).on("keydown",function(e){
			var sItem;
			if(e.keyCode === 38 || e.keyCode === 40){
				clearTimeout(spjs.ac.data[argObj.applyTo].timeout);
				if(jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected").length===0){
					if(e.keyCode === 40){
						sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
					}else if(e.keyCode === 38){
						sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last").addClass("spjs_acSelected");
					}
				}else{
					sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
					if(e.keyCode === 40){ // Down
						sItem.removeClass("spjs_acSelected");
						if(sItem.next().length>0){
							sItem.nextAll().each(function(i,e){
								if(jQuery(e).hasClass("spjs_acItem")){
									sItem = jQuery(e);
									return false;
								}else if(jQuery(e).hasClass("spjs_acItemMoreItems")){
									sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");					
								}							
							});
							sItem.addClass("spjs_acSelected");
						}else{
							sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:first").addClass("spjs_acSelected");
						}
					}else if(e.keyCode === 38){ // Up
						sItem.removeClass("spjs_acSelected");
						if(sItem.prev().length>0){
							sItem.prevAll().each(function(i,e){
								if(jQuery(e).hasClass("spjs_acItem")){
									sItem = jQuery(e);
									return false;
								}else{
									sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last");					
								}						
							});							
							sItem.addClass("spjs_acSelected");
						}else{
							sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acItem:last").addClass("spjs_acSelected");
						}						
					}
				}
			}else if(e.keyCode === 13){
				sItem = jQuery("#spjs_acPlaceholder_"+argObj.applyTo).find("div.spjs_acSelected");
				if(sItem.length>0){
					spjs.ac.data[argObj.applyTo].selectedIndex = sItem.attr("aindex");
					spjs.ac.data[argObj.applyTo].selectedValue = sItem.text();
					jQuery("#spjs_ac_"+argObj.applyTo).val(jQuery(sItem).text());
					jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide();
					spjs.ac.data[argObj.applyTo].clicked = true;
					spjs.ac.verify(argObj.applyTo);
				}else{
					spjs.ac.data[argObj.applyTo].selectedIndex = 0;
					spjs.ac.data[argObj.applyTo].selectedValue = "";
				}
				return false;
			}
		});
		if(jQuery("#spjs_ac_"+argObj.applyTo).val() !== ""){
			if(argObj.reValidateOnLoad){
				spjs.ac.data[argObj.applyTo].trigger = true;			
				clearTimeout(spjs.ac.data[argObj.applyTo].timeout);
				spjs.ac.data[argObj.applyTo].timeout = setTimeout(function(){				
					spjs.ac.handle(argObj);
				},500);
			}
		}else{
			jQuery("#spjs_acHelp_"+argObj.applyTo).show();
		}
	},
	"destroy":function(fin){
		if(jQuery("#spjs_acWrap_"+fin).length > 0){
			jQuery("#spjs_acWrap_"+fin).remove();
			jQuery("#spjs_acPlaceholder_"+fin).remove();
			jQuery("#spjs_acError_"+fin).remove();
			jQuery(fields[fin]).attr("spjs_ac","0");
			jQuery(fields[fin]).find("td.ms-formbody span:first").show();
			clearTimeout(spjs.ac.data[fin].timeout);			
			delete spjs.ac.data[fin];
		}
	},
	"GetUserCollectionFromGroup":function(gName){
		var result = {"items":[]}, pArr = [["ID","ID"], ["Name","Title"], ["LoginName","Name"], ["Email","EMail"], ["IsSiteAdmin","IsSiteAdmin"],["IsDomainGroup","IsDomainGroup"]], d;
		spjs_wrapSoapRequest(spjs.ac.data.baseUrl + '/_vti_bin/usergroup.asmx', 
		'http://schemas.microsoft.com/sharepoint/soap/directory/GetUserCollectionFromGroup',
		'<GetUserCollectionFromGroup xmlns="http://schemas.microsoft.com/sharepoint/soap/directory/"><groupName>' + gName + '</groupName></GetUserCollectionFromGroup>',
		function(data){		
			jQuery('User', data).each(function(idx, data){
				d = {};
				jQuery.each(pArr,function(i,a){
					d[a[1]] = jQuery(data).attr(a[0]);
				});
				result.items.push(d);
			});
		});
		result.count = result.items.length;
		return result;
	},
	"searchUserCollectionFromGroup":function(str,gName){
		if(spjs.ac.data.usersInGroup[gName] === undefined){
			spjs.ac.data.usersInGroup[gName] = spjs.ac.GetUserCollectionFromGroup(gName);
		}
		var fRes = {"items":[]}, m, pArr = ["ID", "Title", "Name", "EMail", "IsSiteAdmin", "IsDomainGroup"];
		jQuery.each(spjs.ac.data.usersInGroup[gName].items,function(i,o){
			m = false;			
			jQuery.each(o,function(j,p){
				if(jQuery.inArray(j,pArr) > -1){
					if(p.toLowerCase().indexOf(str.toLowerCase()) > -1){
						m = true;
					}
				}
			});
			if(m){
				fRes.items.push(o);
			}
		});
		fRes.count = fRes.items.length;
		return fRes;
	},
	"handle":function(argObj){
		spjs.ac.data[argObj.applyTo].addNew = false;
		var val, viewFields, query, res;
		val = jQuery("#spjs_ac_"+argObj.applyTo).val();		
		spjs.ac.data[argObj.applyTo].currentValue = val;		
		spjs.ac.data[argObj.applyTo].clicked = false;		
		if(val !== "" || (val === "" && argObj.listOptionsOnFocus)){
			if(!spjs.ac.data[argObj.applyTo].trigger && val !== "" && jQuery("#spjs_acPlaceholder_"+argObj.applyTo).css("display") === "none"){
				jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html("<div style='padding:4px;color:#818181;'>"+spjs.ac.data[argObj.applyTo].text.searching+val+"...</div>").show();
			}			
			jQuery("#statusImg_"+argObj.applyTo).attr("src","/_layouts/images/IMNOFF.PNG").hide();
			jQuery("#prosessingImg_"+argObj.applyTo).show();
			setTimeout(function(){
				if(argObj.fieldType === "peoplePicker"){				
					if(argObj.chooseFromUserGroup !== null){
						if(typeof argObj.chooseFromUserGroup === "number"){
							argObj.chooseFromUserGroup = getUserInfo_v2(argObj.chooseFromUserGroup).Name;
						}
						res = spjs.ac.searchUserCollectionFromGroup(val,argObj.chooseFromUserGroup);
					}else{
						query = [];						
						if(val === ""){							
							if(argObj.showUsersOnly){
								query.push("<And><IsNotNull><FieldRef Name='ID' /></IsNotNull><Eq><FieldRef Name='ContentType' /><Value Type='Text'>Person</Value></Eq></And>");
							}else{
								query.push("<IsNotNull><FieldRef Name='ID' /></IsNotNull>");
							}
						}else{
							query.push("<Or>");
							query.push("<Or>");
							query.push("<Contains><FieldRef Name='Title' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
							query.push("<Contains><FieldRef Name='Name' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
							query.push("</Or>");
							query.push("<Contains><FieldRef Name='EMail' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains>");
							query.push("</Or>");
						}
						if(argObj.showUsersOnly){
							query.unshift("<And>");
							query.push("<Eq><FieldRef Name='ContentType' /><Value Type='Text'>Person</Value></Eq>");
							query.push("</And>");
						}
						query.unshift("<Where>");
						query.push("</Where>");
						query.push("<OrderBy><FieldRef Name='"+argObj.showField+"' /></OrderBy>");
						viewFields = ["ID"];
						viewFields.push(argObj.showField);
						jQuery.each(spjs.ac.data[argObj.applyTo].setFields,function(i,o){
							if(jQuery.isArray(o.fromFIN)){
								jQuery.each(o.fromFIN,function(i,f){
									viewFields.push(f);
								});
							}else{
								viewFields.push(o.fromFIN);
							}
						});
						res = spjs_QueryItems({"listName":argObj.listGuid,"query":query.join(""),"viewFields":viewFields,"rowLimit":argObj.rowLimit});
					}
				}else{
					if(val === "" && argObj.listOptionsOnFocus){
						query = "<Where><IsNotNull><FieldRef Name='"+argObj.showField+"' /></IsNotNull></Where><OrderBy><FieldRef Name='"+argObj.showField+"' /></OrderBy>";
					}else{
						query = "<Where><Contains><FieldRef Name='"+argObj.showField+"' /><Value Type='Text'>"+val.replace(/&/g,"&amp;")+"</Value></Contains></Where><OrderBy><FieldRef Name='"+argObj.showField+"' /></OrderBy>";
					}
					viewFields = ["ID"];
					viewFields.push(argObj.showField);
					jQuery.each(spjs.ac.data[argObj.applyTo].setFields,function(i,o){
						if(jQuery.isArray(o.fromFIN)){
							jQuery.each(o.fromFIN,function(i,f){
								viewFields.push(f);
							});
						}else{
							viewFields.push(o.fromFIN);
						}
					});
					res = spjs_QueryItems({"listName":argObj.listGuid,"listBaseUrl":argObj.listBaseUrl,"query":query,"viewFields":viewFields,"rowLimit":argObj.rowLimit});
				}
				jQuery("#spjs_acError_"+argObj.applyTo).hide();
				if(res.count===-1){
					jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide();
					jQuery("#spjs_acError_"+argObj.applyTo).html("Ensure the list \""+argObj.listGuid+"\" exists on \""+argObj.listBaseUrl+"\", and that the field \""+argObj.showField+"\" does exist in that list.").show();
					jQuery(fields[argObj.applyTo]).find("input").val("");
				}else if(res.count===0){
					var b = [];
					jQuery(fields[argObj.applyTo]).find("input:first").val("");
					if(val !== ""){
						b.push("<div class='spjs_acNotFound'>"+spjs.ac.data[argObj.applyTo].text.noItems);
						if(argObj.allowAddNew){
							b.push(" - <span style='color:red;cursor:pointer;' onclick='spjs.ac.addNewItem(\""+argObj.applyTo+"\")'>"+spjs.ac.data[argObj.applyTo].text.addNewItem.replace("{0}","<i>"+val+"</i>")+"</span>");
						}
						b.push("</div>");
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html(b.join(""));				
					}else{
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).hide();
					}
					spjs.ac.data[argObj.applyTo].selectedIndex = 0;
				}else{
					spjs.ac.data[argObj.applyTo].sFields = {};
					spjs.ac.data[argObj.applyTo].foundExactMatch = 0;
					spjs.ac.getChoices(res.items,argObj,val,argObj.fieldType);
					if(res.count > 0 && spjs.ac.data[argObj.applyTo].choices.length === 0){
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html("<div class='spjs_acNotFound'>"+spjs.ac.data[argObj.applyTo].text.noValidItems+"</div>");
						jQuery("#spjs_ac_"+argObj.applyTo).focus();
						jQuery("#spjs_acPlaceholder_"+argObj.applyTo).show();						
					}else{
						if(spjs.ac.data[argObj.applyTo].trigger){										
							if(spjs.ac.data[argObj.applyTo].foundExactMatch > 0){								
								spjs.ac.data[argObj.applyTo].selectedIndex = spjs.ac.data[argObj.applyTo].foundExactMatch;
								spjs.ac.data[argObj.applyTo].selectedValue = jQuery("#spjs_ac_"+argObj.applyTo).val();		
								spjs.ac.data[argObj.applyTo].currentValue = spjs.ac.data[argObj.applyTo].selectedValue;								
							}
							spjs.ac.data[argObj.applyTo].trigger = false;
							spjs.ac.verify(argObj.applyTo);
						}else{						
							if(spjs.ac.data[argObj.applyTo].foundExactMatch > 0){								
								spjs.ac.data[argObj.applyTo].selectedIndex = spjs.ac.data[argObj.applyTo].foundExactMatch;
								spjs.ac.data[argObj.applyTo].selectedValue = jQuery("#spjs_ac_"+argObj.applyTo).val();		
								spjs.ac.data[argObj.applyTo].currentValue = spjs.ac.data[argObj.applyTo].selectedValue;								
							}else{						
								jQuery(fields[argObj.applyTo]).find("input:first").val("");
								spjs.ac.data[argObj.applyTo].selectedIndex = 0;
							}
							if(spjs.ac.data[argObj.applyTo].choices.length === argObj.rowLimit){
								spjs.ac.data[argObj.applyTo].choices.push("<div class='spjs_acItemMoreItems' title='"+spjs.ac.data[argObj.applyTo].text.moreItemsMouseover+"'>"+spjs.ac.data[argObj.applyTo].text.moreItemsLabel.replace("{0}",argObj.rowLimit)+"</div>");
							}
							jQuery("#spjs_acPlaceholder_"+argObj.applyTo).html(spjs.ac.data[argObj.applyTo].choices.join(""));										
							jQuery("#spjs_ac_"+argObj.applyTo).focus();
							jQuery("#spjs_acPlaceholder_"+argObj.applyTo).show();
						}
					}
				}
				setTimeout(function(){
					jQuery("#prosessingImg_"+argObj.applyTo).hide();
					jQuery("#statusImg_"+argObj.applyTo).show();					
				},500);
			},100);			
		}
	},
	"addNewItem":function(fin){
		var a = spjs.ac.data.argObj[fin], v = spjs.ac.data[a.applyTo].currentValue;
		if(a.isLookupInSelf){
			jQuery(fields[a.applyTo]).find("input:first").val(v);
			spjs.ac.data[a.applyTo].selectedValue = v;
			spjs.ac.data[a.applyTo].addNew = true;
			jQuery(fields[a.applyTo]).find("input:first").show();
		}else{
			OpenPopUpPage(a.listBaseUrl+"/_layouts/15/listform.aspx?PageType=8&ListId="+a.listGuid,function(result){
				if(result === 1){
					jQuery("#spjs_ac_"+fin).val(v);
					spjs.ac.handle(a);
				}
			});
			spjs.ac.prefill(a.showField,v);
		}
	},
	"prefill":function(fin,val){
		var dlg = SP.UI.ModalDialog.get_childDialog().get_frameElement();
		if(dlg !== undefined){
			if(jQuery(dlg).contents().find("input[id^='"+fin+"_']").length < 1){
				setTimeout(function(){
					spjs.ac.prefill(fin,val);
				},100);
			}else{
				jQuery(dlg).contents().find("input[id^='"+fin+"_']").val(val);
			}
		}		
	},
	"getChoices":function(items,argObj,val,type){
		spjs.ac.data[argObj.applyTo].choices = [];
		var bSel, skip, sVal, lVal, b, unique = {};
		bSel = null;
		jQuery.each(items,function(i,item){
			skip = false;
			spjs.ac.data[argObj.applyTo].sFields[item.ID] = [];
			jQuery.each(spjs.ac.data[argObj.applyTo].setFields,function(j,o){
				if(jQuery.isArray(o.fromFIN)){
					jQuery.each(o.fromFIN,function(i,f){
						sVal = item[f];
						if(sVal !== null){							
							return false;
						}else{
							sVal = "";
						}
					});
					
				}else{
					sVal = item[o.fromFIN] !== null ? item[o.fromFIN] : "";
				}
				if(sVal === "" && o.skipIfEmpty){
					skip = true;
					return false;
				}			
				spjs.ac.data[argObj.applyTo].sFields[item.ID].push({"fin":o.toFIN,"val":sVal,"pf":o.parseFunction !== undefined ? o.parseFunction : ""});
			});
			if(skip){
				return;
			}
			lVal = item[argObj.showField];
			if(unique[lVal] !== undefined && argObj.enforceUniqueValues){
				return;
			}
			unique[lVal] = true;
			lVal = lVal.replace(/'/g,"&apos;").replace(/"/g,"&quot;");
			if(lVal.split(";#").length>1){
				lVal = lVal.split(";#")[1];
			}
			b = [];
			if(type === "peoplePicker" && item.EMail !== null){
				b.push("<div title='"+item.EMail+"' aindex='"+item.ID+"' class='spjs_acItem");
			}else{
				b.push("<div title='"+lVal+"' aindex='"+item.ID+"' class='spjs_acItem");
			}			
			if(lVal === val){
				if(bSel === null){
					b.push(" spjs_acSelected");
					bSel = true;
					spjs.ac.data[argObj.applyTo].foundExactMatch = item.ID;
				}else if(bSel){
					bSel = false;
					spjs.ac.data[argObj.applyTo].foundExactMatch = 0;
				}					
			}
			b.push("' onmouseover='spjs.ac.hover(\""+argObj.applyTo+"\",this)' onclick='spjs.ac.select(\""+argObj.applyTo+"\",this)' value='"+lVal+"'>"+lVal+"</div>");
			spjs.ac.data[argObj.applyTo].choices.push(b.join(""));
		});
	},
	"hover":function(fin,elm){
		jQuery(".spjs_acSelected").removeClass("spjs_acSelected");
		jQuery(elm).addClass("spjs_acSelected");
	},
	"select":function(fin,elm){
		spjs.ac.data[fin].clicked = true;
		jQuery("#spjs_ac_"+fin).val(jQuery(elm).text());
		var index;		
		if(elm === undefined){
			elm = jQuery("#spjs_acPlaceholder_"+fin).find("div.spjs_acSelected");			
		}
		index = jQuery(elm).attr("aindex");
		spjs.ac.data[fin].selectedIndex = index;
		spjs.ac.data[fin].selectedValue = jQuery("#spjs_ac_"+fin).val();		
		spjs.ac.data[fin].currentValue = spjs.ac.data[fin].selectedValue;
		jQuery("#spjs_acPlaceholder_"+fin).hide();		
		jQuery("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
		spjs.ac.verify(fin);
	},
	"verify":function(fin){		
		var index, cVal;
		cVal = jQuery("#spjs_ac_"+fin).val();
		index = spjs.ac.data[fin].selectedIndex;
		if(index === null){
			// Not changed		
		}else if(index===0 || spjs.ac.data[fin].selectedValue !== cVal){
			if(spjs.ac.data[fin].addNew){
				jQuery("#statusImg_"+fin).attr("src","/_layouts/images/IMNONOOF.PNG");
			}else{
				setFieldValue(fin,"");
				jQuery("#spjs_ac_"+fin).val(cVal);
				jQuery.each(spjs.ac.data[fin].setFields,function(i,o){
					setFieldValue(o.toFIN,"");				
				});
				if(cVal !== ""){
					jQuery("#spjs_ac_"+fin).addClass("spjs_acError").attr("title",spjs.ac.data[fin].text.invalid);
					jQuery("#statusImg_"+fin).attr("src","/_layouts/images/IMNBUSY.PNG");
				}else{
					jQuery("#statusImg_"+fin).attr("src","/_layouts/images/IMNOFF.PNG");
				}
			}		
		}else{
			jQuery("#spjs_acHelp_"+fin).hide();
			jQuery("#spjs_ac_"+fin).removeClass("spjs_acError").attr("title","");
			jQuery("#statusImg_"+fin).attr("src","/_layouts/images/IMNON.PNG");
			setFieldValue(fin,spjs.ac.data[fin].selectedValue);
			if(index!==""){
				jQuery.each(spjs.ac.data[fin].sFields[index],function(i,o){
					if(o.pf !== ""){
						try{
							o.val = window[o.pf](o.val);
						}catch(ignore){
							// Nothing
						}
					}else{
						if(o.val.split(";#").length > 1){
							o.val = o.val.split(";#")[1];
						}
					}
					setFieldValue(o.fin,o.val);
					switch(jQuery(fields[o.fin]).attr("FieldType")){
						case "SPFieldChoice":
							jQuery(fields[o.fin]).find("select").trigger("change");
						break;
						case "SPFieldMultiChoice":
							jQuery(fields[o.fin]).find("input:checkbox").trigger("change");
						break;
						default:
							jQuery(fields[o.fin]).find("input:text").trigger("blur");
					}
					if(jQuery(fields[o.fin]).find("td.ms-formbody").length > 1){
						if(jQuery(fields[o.fin]).attr("FieldType").match("SPFieldUser") !== null && o.val !== ""){
							jQuery(fields[o.fin]).find("td.ms-formbody").last().html("...");
							spjs.ac.updateReadonlyPeoplePicker(o.fin,0);
						}else{
							jQuery(fields[o.fin]).find("td.ms-formbody").last().html(o.val);
						}
					}
				});
			}	
		}
	},
	"updateReadonlyPeoplePicker":function(fin,c){
		if(c > 10){			
			return;
		}
		var ppVal = getFieldValue(fin);
		if(ppVal !== ""){
			jQuery(fields[fin]).find("td.ms-formbody").last().html(ppVal);
		}else{
			setTimeout(function(){				
				spjs.ac.updateReadonlyPeoplePicker(fin,(c+1));
			},1000);
		}
	}
};